<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  creationComplete="creationCompleteHandler(event)" title="Cadastro de Usuario/Acao" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="UsuarioacaoIncluidoEvent")]
		[Event(name="UsuarioacaoAtualizadoEvent")]
		[Event(name="UsuarioacaoExcluidoEvent")]
		[Event(name="UsuarioacaoSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.Tree;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import spark.events.DropDownEvent;
			import spark.events.IndexChangeEvent;
			
			import br.com.desenv.nepalign.vo.Empresa;
			import br.com.desenv.nepalign.vo.Funcionalidade;
			import br.com.desenv.nepalign.vo.Modulo;
			import br.com.desenv.nepalign.vo.Usuario;
			import br.com.desenv.nepalign.vo.Usuarioacao;
			// Alguem passa a objeto para ca
			public var usuarioacao : Usuarioacao = new Usuarioacao();
			public var modulo: Modulo = new Modulo();
			public var funcionalidade:Funcionalidade = new Funcionalidade();
			
			[Bindable]
			private var listaEmpresa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaUsuario: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaModulo: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaFuncionalidade: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var usuarioContemDataProvider:XML = null;
			[Bindable]
			private var usuarioNContemDataProvider:XML = null;
			

			/************************  FUNCOES NOVO COMPONENTE - TREE - ************************/
			
			private function popularArvore():void
			{
				if(ignComboBoxAutoCompleteUsuario.selectedIndex != -1 && ignComboBoxAutoCompleteEmpresa.selectedIndex != -1)
				{
					var remoteObjectProviderTree: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioacaoService", mCallbackTreeNContains);
					remoteObjectProviderTree.getOperation("GenerateXML").send(ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem);
					
					
					var remoteObjectvalidaLogin: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioacaoService", mCallbackTreeContains);
					remoteObjectvalidaLogin.getOperation("GenerateNotInXML").send(ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem, ignComboBoxAutoCompleteFuncionalidade.selectedItem, ignComboBoxAutoCompleteModulo.selectedItem);
				}
			}
			
			private function mCallbackUpdateTree(event:ResultEvent):void
			{
				this.popularArvore();
			}
			
			private function mCallbackTreeNContains(event:ResultEvent):void
			{
				var resultXML:XML = event.result as XML;
				if(resultXML == null)
					this.usuarioNContemDataProvider = null;
				else
					this.usuarioNContemDataProvider = resultXML;
			}
			
			private function mCallbackTreeContains(event:ResultEvent):void
			{
				var resultXML:XML = event.result as XML;
				if(resultXML == null)
					this.usuarioContemDataProvider = null;
				else
					this.usuarioContemDataProvider = resultXML;
			}
			
			private function gerarXml(acao:int, treeObject:Tree):XML
			{
				switch(acao)
				{
					case 0:
						var sendXML:XML; //Alloc data to send 
						var selectedTreeItem = treeObject.selectedItem; //Aloc tree selected item data
						var decodedXML:String;
						if(selectedTreeItem.children().length() > 0) // é uma pasta
						{
							if(selectedTreeItem.children().children().length() > 0) // é um módulo!
								decodedXML = selectedTreeItem.children().children().toXMLString();
							else
								decodedXML = selectedTreeItem.children().toXMLString();
						}
						else
						decodedXML = selectedTreeItem.toXMLString();
						decodedXML = "<root> " + decodedXML + " </root>"; //Add a root node, for identification
						sendXML = new XML(decodedXML);
						return sendXML;
					
					case 1:
						return treeObject.dataProvider as XML;
					
					default:
						return null;
				}
			}
			
			private function HandleRequestAction(action:int):void
			{
				var remoteTransaction:RemoteObject = AMFConnector.instance.prepararObjetoRemoto("usuarioacaoService", mCallbackUpdateTree);
				switch(action)
				{
					case 0: // Adicionar item (1)
						remoteTransaction.getOperation("incluirListaUsuarioacao").send(this.gerarXml(0, usuarioContem), ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem); //Send xml and user to Java!
						break;
					
					case 1: // Adicionar tudo
						remoteTransaction.getOperation("incluirListaUsuarioacao").send(usuarioContemDataProvider, ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem); //Send xml and user to Java!
						break;
					
					case 2: // Remover item (1)
						remoteTransaction.getOperation("excluirListaUsuarioacao").send(this.gerarXml(0, usuarioNContem), ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem); //Send xml and user to Java!
						break;
					
					case 3: // Remover tudo
						remoteTransaction.getOperation("excluirListaUsuarioacao").send(usuarioNContemDataProvider, ignComboBoxAutoCompleteUsuario.selectedItem, ignComboBoxAutoCompleteEmpresa.selectedItem); //Send xml and user to Java!
						break;
				}
			}
			
			private function adicionarUm(event:MouseEvent):void
			{
				this.HandleRequestAction(0);
			}
			
			private function adicionarTodos(event:MouseEvent):void
			{
				this.HandleRequestAction(1);
			}
			
			private function removerUm(event:MouseEvent):void
			{
				this.HandleRequestAction(2);
			}
			
			private function removerTodos(event:MouseEvent):void
			{
				this.HandleRequestAction(3);
			}
			
			protected function ignComboBoxAutoCompleteModulo_changeHandler(event:IndexChangeEvent):void
			{
				if(ignComboBoxAutoCompleteModulo.selectedIndex == 0)
					ignComboBoxAutoCompleteModulo.selectedIndex = -1;
				this.popularArvore();
			}
			
			protected function ignComboBoxAutoCompleteFuncionalidade_changeHandler(event:IndexChangeEvent):void
			{
				if(ignComboBoxAutoCompleteFuncionalidade.selectedIndex == 0)
					ignComboBoxAutoCompleteFuncionalidade.selectedIndex = -1;
				this.popularArvore();
			}
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------		
			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignComboBoxAutoCompleteFuncionalidade.selectedIndex = -1;
				ignComboBoxAutoCompleteModulo.selectedIndex = -1;
				ignComboBoxAutoCompleteUsuario.selectedIndex = -1;
				ignComboBoxAutoCompleteEmpresa.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				var remoteObjectEmpresa: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaService", listarEmpresaResultHandler);	
				remoteObjectEmpresa.getOperation("listar").send();
				var remoteObjectUsuario: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioService", listarUsuarioResultHandler);	
				remoteObjectUsuario.getOperation("listar").send();
				var remoteObjModulo: RemoteObject = AMFConnector.instance.prepararObjetoRemoto("moduloService", listarModuloResultHandler);
				remoteObjModulo.getOperation("listar").send();
				var remoteObjFuncionalidade: RemoteObject = AMFConnector.instance.prepararObjetoRemoto("funcionalidadeService", listarFuncionalidadeResultHandler);
				remoteObjFuncionalidade.getOperation("listar").send();
				
				/* Não utilizado! Descomentar caso seja útil! OBS : TextInput da ação retirado!
				if (this.usuarioacao.id == 0)
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{

					if (this.usuarioacao.acao != null)
					{
						ignTextInputAcao.text = usuarioacao.acao.id + " - " + usuarioacao.acao.descricao;
					}
					ignTextInputAcao.editable = false;
					//ignComboBoxAutoCompleteUsuario.selectedItem = this.usuarioacao.usuario;
					//ignComboBoxAutoCompleteEmpresa.selectedItem = this.usuarioacao.empresa;*
				}*/
			}
			
			private function listarModuloResultHandler( event: ResultEvent ): void 
			{
				this.listaModulo = event.result as ArrayCollection;
				this.listaModulo.addItemAt(null, 0);
			}
			
			private function listarFuncionalidadeResultHandler( event: ResultEvent ): void 
			{
				this.listaFuncionalidade = event.result as ArrayCollection;
				this.listaFuncionalidade.addItemAt(null, 0);
			}
			
			private function listarEmpresaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresa = event.result as ArrayCollection;
				listaEmpresa.addItemAt(null, 0);
				
				if (this.usuarioacao != null && this.usuarioacao.empresa != null)
				{
					for(var i:int = 1; i <= this.listaEmpresa.length; i++)
					{
						var empresaTemp: Empresa = this.listaEmpresa.getItemAt(i) as Empresa;
						
						if (empresaTemp.id == this.usuarioacao.empresa.id)
						{
							ignComboBoxAutoCompleteEmpresa.selectedIndex = i;
							break;
						}
					}
				}	
			}
			private function listarUsuarioResultHandler( event: ResultEvent ): void 
			{
				listaUsuario = event.result as ArrayCollection;
				listaUsuario.addItemAt(null, 0);
				
				if (this.usuarioacao != null && this.usuarioacao.usuario != null)
				{
					for(var i:int = 1; i <= this.listaUsuario.length; i++)
					{
						var usuarioTemp: Usuario = this.listaUsuario.getItemAt(i) as Usuario;
						
						if (usuarioTemp.id == this.usuarioacao.usuario.id)
						{
							ignComboBoxAutoCompleteUsuario.selectedIndex = i;
							break;
						}
					}
				}	
			}
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (usuarioacao.id != 0) 
					{
						//usuarioacao.acao = // Carregado via popup				
						usuarioacao.usuario = ignComboBoxAutoCompleteUsuario.selectedItem; 
						usuarioacao.empresa = ignComboBoxAutoCompleteEmpresa.selectedItem; 
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioacaoService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(usuarioacao); 
					// Se e inclusao
					} 
					else 
					{
						usuarioacao.usuario = ignComboBoxAutoCompleteUsuario.selectedItem; 
						usuarioacao.empresa = ignComboBoxAutoCompleteEmpresa.selectedItem; 
						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioacaoService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(usuarioacao); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.usuarioacao = event.result as Usuarioacao;
				this.dispatchEvent(new ResultEvent("UsuarioacaoIncluidoEvent",false, true, this.usuarioacao, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.usuarioacao = event.result as Usuarioacao;
				this.dispatchEvent(new Event("UsuarioacaoAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarAcao_clickHandler(event:MouseEvent):void
			{
				/* Não utilizado! Descomentar caso seja útil! OBS : TextInput da ação retirado!
				var acaoComponentePesquisa: AcaoComponentePesquisa = new AcaoComponentePesquisa();
				acaoComponentePesquisa.addEventListener("AcaoSelecionadoEvent", atualizarAcaoPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(acaoComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(acaoComponentePesquisa);*/
			}
			
			private function atualizarAcaoPorSelecaoResultHandler(e:ResultEvent):void
			{
				/* Não utilizado! Descomentar caso seja útil! OBS : TextInput da ação retirado!
				var novoAcao: Acao = e.result as Acao;
				ignTextInputAcao.text = novoAcao.id + " - " + novoAcao.descricao;
				this.usuarioacao.acao = novoAcao;*/
			}

			protected function buttonAdicionarAcao_clickHandler(event:MouseEvent):void
			{
				/* Não utilizado! Descomentar caso seja útil! OBS : TextInput da ação retirado!
				var acaoComponenteCadastro: AcaoComponenteCadastro = new AcaoComponenteCadastro();
				acaoComponenteCadastro.addEventListener("AcaoIncluidoEvent", atualizarAcaoPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(acaoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(acaoComponenteCadastro);*/
			}
			
			private function atualizarAcaoPorInclusaoResultHandler(e:ResultEvent):void
			{
				/* Não utilizado! Descomentar caso seja útil! OBS : TextInput da ação retirado!
				var novoUsuarioacao: Acao = e.result as Acao;
				ignTextInputAcao.text = novoUsuarioacao.id + " - " + novoUsuarioacao.descricao;
				this.usuarioacao.acao = novoUsuarioacao;*/
			}
			
			protected function buttonAdicionarEmpresa_clickHandler(event:MouseEvent):void
			{
				var empresaComponenteCadastro: EmpresaComponenteCadastro = new EmpresaComponenteCadastro();
				empresaComponenteCadastro.addEventListener("EmpresaIncluidoEvent", atualizarListaEmpresaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(empresaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(empresaComponenteCadastro);
			}
			
			private function atualizarListaEmpresaPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoEmpresa: Empresa = e.result as Empresa;
				listaEmpresa.addItem(novoEmpresa);
				ignComboBoxAutoCompleteEmpresa.selectedItem = novoEmpresa;
			}
			protected function buttonAdicionarUsuario_clickHandler(event:MouseEvent):void
			{
				var usuarioComponenteCadastro: UsuarioComponenteCadastro = new UsuarioComponenteCadastro();
				usuarioComponenteCadastro.addEventListener("UsuarioIncluidoEvent", atualizarListaUsuarioPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(usuarioComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(usuarioComponenteCadastro);
			}
			
			private function atualizarListaUsuarioPorInclusaoResultHandler(e:ResultEvent):void
			{
				var novoUsuario: Usuario = e.result as Usuario;
				listaUsuario.addItem(novoUsuario);
				ignComboBoxAutoCompleteUsuario.selectedItem = novoUsuario;
			}
			
			private function adicionarNovoModulo(event:MouseEvent):void
			{
				var moduloComponenteCadastro: ModuloComponenteCadastro = new ModuloComponenteCadastro();
				moduloComponenteCadastro.addEventListener("ModuloIncluidoEvent", atualizarListaModulo);
				UPCPopUpManager.instance.addPopUp(moduloComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(moduloComponenteCadastro);
			}
			
			private function atualizarListaModulo(event:ResultEvent):void
			{
				var novoModulo:Modulo = event.result as Modulo;
				listaModulo.addItem(novoModulo);
				ignComboBoxAutoCompleteModulo.selectedItem = novoModulo;
			}
			
			private function adicionarNovaFuncionalidade(event:MouseEvent):void
			{
				var funcionalidadeComponenteCadastro: FuncionalidadeComponenteCadastro = new FuncionalidadeComponenteCadastro();
				funcionalidadeComponenteCadastro.addEventListener("FuncionalidadeIncluidoEvent", atualizarListaFuncionalidade);
				UPCPopUpManager.instance.addPopUp(funcionalidadeComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(funcionalidadeComponenteCadastro);
			}
			
			private function atualizarListaFuncionalidade(event:ResultEvent):void
			{
				var novaFuncionalidade:Funcionalidade = event.result as Funcionalidade;
				listaFuncionalidade.addItem(novaFuncionalidade);
				ignComboBoxAutoCompleteFuncionalidade.selectedItem = novaFuncionalidade
			}
			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
			
			protected function ignComboBoxAutoCompleteFuncionalidade_closeHandler(event:DropDownEvent):void
			{
				if(ignComboBoxAutoCompleteFuncionalidade.selectedIndex == 0)
					ignComboBoxAutoCompleteFuncionalidade.selectedIndex = -1;
				this.popularArvore();
			}
			
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoUsuarioacao" property="selectedItem" required="true" source="{comboBoxSituacaoUsuarioacao}" trigger="{comboBoxSituacaoUsuarioacao}" triggerEvent="valueCommit"/> -->
		
	</fx:Declarations>
	
	<mx:Grid styleName="grid">	
		<mx:GridRow horizontalAlign="left">	
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoModulo" text="{ignComboBoxAutoCompleteModulo.errorString}"/>
					<s:HGroup>
						<s:Label text="Módulo: "/>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteModulo" dataProvider="{listaModulo}" labelField="descricao" paddingLeft="10" change="ignComboBoxAutoCompleteModulo_changeHandler(event)"/>
						<s:Button id="buttonAdicionarModulo" width="30" label="+" click="adicionarNovoModulo(event)"/>
					</s:HGroup>		
					<s:Label id="labelValidacaoFuncionalidade" text="{ignComboBoxAutoCompleteFuncionalidade.errorString}"/>
					<s:HGroup>
						<s:Label text="Funcionalidade:"/>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteFuncionalidade" dataProvider="{listaFuncionalidade}" labelField="descricao"  close="ignComboBoxAutoCompleteFuncionalidade_closeHandler(event)"/>
						<s:Button id="buttonAdicionarFuncionalidade" width="30" label="+" click="adicionarNovaFuncionalidade(event)"/> 
					</s:HGroup>	
					<mx:Tree id="usuarioContem" width="300" height="200" labelField="@label" showRoot="false" dataProvider="{usuarioContemDataProvider}" />
				</s:VGroup>
			</mx:GridItem>

			<mx:GridItem>
				<s:VGroup verticalAlign="middle" horizontalAlign="center">
					<s:Spacer height="120"/>
					<s:Button id="incluirTodos" label="&gt;&gt;" width="50" click="adicionarTodos(event)"/>
					<s:Button id="incluirUm" label="&gt;" width="50" click="adicionarUm(event)"/>
					<s:Button id="excluirTodos" label="&lt;&lt;" width="50" click="removerTodos(event)"/>
					<s:Button id="excluirUm" label="&lt;" width="50" click="removerUm(event)"/>
				</s:VGroup>
			</mx:GridItem>
			
			
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:HGroup>
						<s:Label text="Usuario:"/>
						<s:Label id="labelValidacaoUsuario" styleName="labelValidacao" text="{ignComboBoxAutoCompleteUsuario.errorString}"/>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteUsuario" dataProvider="{listaUsuario}" labelField="nome" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}" change="this.popularArvore()"/>
						<s:Button id="buttonAdicionarUsuario" width="30" label="+" click="buttonAdicionarUsuario_clickHandler(event)"/>
					</s:HGroup>
					<s:Label id="labelValidacaoEmpresa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresa.errorString}"/>
					<s:HGroup>
						<s:Label text="Empresa:"/>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresa" dataProvider="{listaEmpresa}" labelField="nomeConcatenado" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}" change="this.popularArvore()"/>
						<s:Button id="buttonAdicionarEmpresa" width="30" label="+" click="buttonAdicionarEmpresa_clickHandler(event)"/>
					</s:HGroup>
					<mx:Tree id="usuarioNContem" width="300" height="200" labelField="@label" showRoot="false" dataProvider="{usuarioNContemDataProvider}" />
				</s:VGroup>
			</mx:GridItem>
			
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>